#include "p33Fxxxx.h"
_FOSCSEL(FNOSC_PRIPLL);	// 1 Ƿ(XT, HS, EC) PLL 
_FOSC(FCKSM_CSDCMD & OSCIOFNC_OFF  & POSCMD_XT);	
// OSC2  Ŭ , 1 Ƿ XT ũŻ 
_FWDT(FWDTEN_OFF); 	// ġ Ÿ̸  

#define FCY      	40000000		// Ʋ ļ
#define BAUDRATE 	9600                	//UART2 Baudrate 9600bps
#define BRGVAL   	((FCY/BAUDRATE)/16)-1

void Initial_Clock(void);
void Initial_UART2(void);

void Initial_PortA(void);

void __attribute__((__interrupt__)) _U2RXInterrupt(void);
void __attribute__((__interrupt__)) _U2TXInterrupt(void);

const unsigned char Hello_UART2[] = {"Hello Interrupt2 UART2 !!!!"};	
//UART2 ۽ ڿ  (α׷ ޸  ġ)
//    : unsigned char UART2_TX_Buf[10];

unsigned char *uart_string;		//۽ ڿ 

volatile unsigned char var_8bit;


typedef union var8bit_struc {
	
	unsigned char var_8bit;
	struct {
		unsigned BIT_0:1;
	unsigned BIT_1:1;
unsigned BIT_2:1;
unsigned BIT_3:1;
unsigned BIT_4:1;
unsigned BIT_5:1;
unsigned BIT_6:1;
unsigned BIT_7:1;
	}v8_b;
} var8bit;

int main(void)
{
	var8bit a;
	
	a.v8_b.BIT_1 = 1;
	
	a.var_8bit = 0xAA;
	
	
	
	Initial_Clock();		//PLL ʱȭ
	Initial_UART2();		//UART2 ʱȭ
	Initial_PortA();		//Ʈ A ʱȭ
	
	uart_string = Hello_UART2;	//۽ ڿ  ʱȭ 
	
	while(1);

}

void Initial_Clock(void)
{
	//Fcy(νƮ Ŭ) Ŭ  : 4.3.4  ļ  
	//Fcy = Fosc / 2 = [ Fxtal X M / (N1 x N2 ) ] / 2
	//Fcy = [ 8MHz X 40 / ( 2 X 2 ) ] / 2 = 80MHz / 2 = 40MHz (40MIPS)

	PLLFBD=38;				// M=40
	CLKDIVbits.PLLPOST=0;		// N1=2
	CLKDIVbits.PLLPRE=0;			// N2=2
	OSCTUN=0;				// FRC Ŭ , Ʃ׽ ʿ

	RCONbits.SWDTEN=0;          		//ġ Ÿ̸   

	while(OSCCONbits.LOCK!=1); 		//PLL LOCK  ٸ
}

void Initial_UART2(void)
{
	U2MODEbits.STSEL = 0;		// 1  Ʈ
	U2MODEbits.PDSEL = 0;		// No иƼ, 8Ʈ   
	U2MODEbits.ABAUD = 0;		// Autobaud 

	U2BRG = BRGVAL;				// 9600 Baudrate , BGR = 259

	U2STAbits.UTXISEL1 = 0;		// ڰ TSR ۸  Ʈ ɶ, ͷƮ ߻
	U2STAbits.UTXISEL0 = 0;

		
	U2STAbits.URXISEL  = 3;		//1  , ͷƮ ߻

	U2MODEbits.UARTEN   = 1;	//UART2    
	U2STAbits.UTXEN     = 1;	//UART2 Tx  

	IFS1bits.U2TXIF = 0;		//UART2 ۽ ͷƮ ÷ Ŭ
	IFS1bits.U2RXIF = 0;		//UART2  ͷƮ ÷ Ŭ

	IEC1bits.U2TXIE = 0;		//UART2 ۽ ͷƮ 
	IEC1bits.U2RXIE = 1;		//UART2  ͷƮ 

	IEC4bits.U2EIE = 0;			//UART2  ͷƮ 

}

void __attribute__((__interrupt__)) _U2RXInterrupt(void)
{
	IFS1bits.U2RXIF = 0;		//UART2  ͷƮ ÷ Ŭ

	if(U2RXREG == ' ')	//ŵ ڰ "SPACE" Ű ġϸ,
	{
			IEC1bits.U2TXIE = 1;		//UART2 ۽ ͷƮ 
	}
}

void __attribute__((__interrupt__)) _U2TXInterrupt(void)
{
	IFS1bits.U2TXIF = 0;		//UART2 ۽ ͷƮ ÷ Ŭ
	
	U2TXREG = *uart_string++;	//۽ ڿ  1 ,  Ŵ

	if(*uart_string == 0 )		//ڿ  Ǿ Ȯ, 
	{
			PORTAbits.RA0 ^= 1;			//LED D3  
			uart_string = Hello_UART2;	//۽ ڿ  ʱȭ
			IEC1bits.U2TXIE = 0;		//UART2 ۽ ͷƮ , ٽ "SPACE" Ű ŵǸ,
										//۽ ͷƮ  
	}
}

void Initial_PortA(void)
{
	TRISA = 0x00;		// RAx    
	//TRISA = 0b00000000;
	PORTA = 0x00;		// LED OFF
}
